program pana (input, output); (*Mediante un alineamiento de secuencias peptidicas
                y con las mismas secuencias pero nucleotidas hace
                un alineamiento "nucleotido" en formato phylip.
                Es una modificacion del PANA original en el que la comprobacion
                se simultanea con la escritura, evitando crear una nueva
                variable de gran tamao *)
uses
    crt;
const
     SpMax=30;      (*Numero maximo de secuencias*)
     TamMaxP=500;   (*Tamao maximo de una secuencia peptidica*)
     TamMaxT=1500;   (* Tamao secuencia nuc. cargada *)
var
     fallo,n,m,i,j,cuentabases,error     :integer;
     NumEspecies,TamSecuencia            :integer;
     numero2,numero1                     :real;
     ADN                                 :array[1..SpMax,1..TamMaxT] of char;
(*     traducido                           :array[1..SpMax,1..TamMaxN] of char; *)
     proteina                            :array[1..SpMax,1..TamMaxP] of char;
     Especies1,Especies2                 :array[1..SpMax] of string[16];
     cuenta                              :array[1..30] of integer;
                                        (* numero de bases en cada Especie *)
     base,cosa                          :char;
     lista1,lista2,cadena,serie         :text;
     FicheroPeptidico,FicheroNucleico   :string[80];
     FicheroResultado                   :string[80];
     existe,correcto,empezar            :boolean;
     total2,total1                      :string[30];


function letter (ch : char) : boolean;
   (* tests whether  ch is a letter
      -- works for both ASCII and EBCDIC codes  *)

begin   (* letter *)
  letter := ((ch >= 'A') AND (ch <= 'I'))
            OR ((ch >= 'J') AND (ch <= 'R'))
            OR ((ch >= 'S') AND (ch <= 'Z'))
            OR ((ch >= 'a') AND (ch <= 'i'))
            OR ((ch >= 'j') AND (ch <= 'r'))
            OR ((ch >= 's') AND (ch <= 'z'));
end;   (* letter *)

procedure uppercase (VAR ch : CHAR);
       (* convert ch to upper case -- either ASCII or EBCDIC  *)
begin (* uppercase *)
  IF letter(ch) AND  (('a' > 'A') AND (ch >= 'a')
                OR ('a' < 'A') AND (ch < 'A'))
  THEN ch := CHR(ORD(ch) + ORD('A') - ORD('a'));
end;  (* uppercase *)  



                                  (*sirve para leer el numero de especies y
                            el tamao de las secuencias en un fichero phylip*)


procedure mensaje;
var
   contador:integer;
   serie1:text;
   linea:string[80];
begin
     writeln;
     assign(serie1,'PANA.DOC');
     reset(serie1);
     CONTADOR:=0;
     while not eof(serie1) do
     begin
          contador := contador + 1;
          readln(serie1,linea);
          writeln(linea);
          if contador div 22 = contador/22 then
          begin
               writeln;
               writeln('                    APRIETA A <INTRO>');
               READLN;
          end;
     end;
     close(serie1);
     writeln;writeln;
     writeln;writeln;
     writeln;writeln('           Aprieta a <INTRO> para ir al men general ');
     readln;
end;





 Procedure InicioDelPrograma;
begin
     writeln;writeln;
     for n:=1 to 80 do write('');
     writeln('                ALINEAMIENTO PANA            ver 2.0');
     writeln('      (c) Luis Rubio, Dpt. Gentica, Univ. Valencia. Ultima Rev 8-5-91');
     for n:=1 to 80 do write('');
     writeln;
end;


procedure  Pregunta;  (* pide el nombre de los ficheros *)
begin;

   writeln;
   writeln( 'Archivos de datos ');
   writeln('Nombre del conjunto de secuencias peptidicas:  ');
   readln(FicheroPeptidico);
   writeln;
   writeln('Nombre del conjunto de secuencias nucleotidicas:  ');
   readln(FicheroNucleico);
   writeln;
   writeln('Nombre del archivo de resultados:   ');
   readln(FicheroResultado);
   writeln;
end;



procedure LeeFicherosDeEntrada;
var
   linea                                  :string[80];
   contadorBloques,ContadorEspecies       :integer;
   cuentaletras                           :array[1..SpMax] of integer;
   HayLetra                               :boolean;
begin;
          (*LEE EL FICHERO PEPTIDICO*)
     assign(lista1,FicheroPeptidico);
                      (* calculo del N de especies*);
     reset(lista1);
     for n:=1 to 3 do readln(lista1,linea);
     Hayletra:=true;
     while HayLetra=true do
     begin
          readln(lista1,base);
          if base in ['A'..'Z','a'..'z'] then
             NumEspecies := NumEspecies + 1
          else
             HayLetra:=false;
     end;
     close(lista1);
                      (* carga de los aminoacidos en una matriz *)
     reset(lista1);
     ContadorBloques:=0;
     for n:=1 to 3 do readln(lista1,linea);
     For n:=1 to NumEspecies do cuentaletras[n]:=0;
     while not eof(lista1) do
     begin
          ContadorEspecies:= 0;
          ContadorBloques := ContadorBloques + 1;
          for n:=1 to NumEspecies do
          begin
            read(lista1,Especies1[n]);
            repeat
                read(lista1,base);
                uppercase(base);
                if (base in ['A'..'Z','-']) and
                   (not (base in ['B','J','O','U']))
                then begin
                    cuentaLetras[n] := cuentaLetras[n] + 1;
                    proteina[n,cuentaLetras[n]]:=base;
                end;
             until eoln(lista1);
             readln(lista1);
         end;
         readln(lista1);
         readln(lista1);
     end;
     close(lista1);
     Tamsecuencia:=cuentaletras[1];

     (* LEE EL FICHERO NUCLEOTIDICO*)
     assign(lista2,FicheroNucleico);
     reset(lista2);
     cuentabases:=0;
     for m:=1 to NumEspecies do
     begin
          Especies2[m]:='';
          cuentabases:=0;
          repeat
                read(lista2,base);
                if (base<>' ') and (ord(base)>34) and (base<>'>')
                 then Especies2[m]:=Especies2[m]+upcase(base);
          until (ord(base)<34) or (base=' ');
          while  (base<>'>')  and (not (eof(lista2))) do
          begin
               read(lista2,base);
               uppercase(base);
               if (base in ['A','G','C','T','N','U','X']) then begin
                      cuentabases := cuentabases + 1;
                      ADN[m,cuentabases] := base;
                      cuenta[m]:=cuentabases;
                  end;
           end;
     end;
     close(lista2);
end;




Procedure Comprobacion;
begin
        (*COMPROBACION PARA VER SI LAS SECUENCIAS PEPTIDICAS Y
        LAS AMINOACIDICAS   LAS MISMAS
     for m:=1 to NumEspecies do
     if Especies1[m]<>Especies2[m] then
     begin
          writeln;
          write('  ERROR.');
          writeln('Las secuencias peptidicas no son las mismas que las  ');
          writeln('nucleotidicas o bien no estn colocadas en el mismo orden    ');
          writeln('PROGRAMA ABORTADO.');
          writeln;writeln;writeln;
          exit;
     end;         *)

     (* EL ALGORITMO Y COMPROBACION PARA VER SI SE ASOCIA A CADA AMINOACIDO
        EL TRIPLETE CORRECTO *)
     fallo:=0;
     for m:=1 to NumEspecies do
     begin
          cuentabases:=0;
         for n:=0 to TamSecuencia-1 do
         begin
             if proteina[m,n+1]<>'-' then begin
                cuentabases := cuentabases + 1;
                correcto := false;
                if (proteina[m,n+1]='X') then correcto:=true;
                if (proteina[m,n+1]='G') and (ADN[m,3*(cuentabases-1)+1]='G')
                  and (ADN[m,3*(cuentabases-1)+2]='G') then correcto:=true;
                if (proteina[m,n+1]='V') and (ADN[m,3*(cuentabases-1)+1]='G')
                  and (ADN[m,3*(cuentabases-1)+2]='T') then correcto:=true;
                if (proteina[m,n+1]='A') and (ADN[m,3*(cuentabases-1)+1]='G')
                  and (ADN[m,3*(cuentabases-1)+2]='C') then correcto:=true;
                if (proteina[m,n+1]='T') and (ADN[m,3*(cuentabases-1)+1]='A')
                  and (ADN[m,3*(cuentabases-1)+2]='C') then correcto:=true;
                if (proteina[m,n+1]='P') and (ADN[m,3*(cuentabases-1)+1]='C')
                  and (ADN[m,3*(cuentabases-1)+2]='C') then correcto:=true;
                if (proteina[m,n+1]='E') and (ADN[m,3*(cuentabases-1)+1]='G')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                    ((ADN[m,3*(cuentabases-1)+3]='G') or
                    (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='D') and (ADN[m,3*(cuentabases-1)+1]='G')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                    ((ADN[m,3*(cuentabases-1)+3]='C') or
                    (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='F') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='T') and
                   ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='Y') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                   ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='C') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='G') and
                   ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='K') and (ADN[m,3*(cuentabases-1)+1]='A')
                   and (ADN[m,3*(cuentabases-1)+2]='A') and
                   ((ADN[m,3*(cuentabases-1)+3]='G') or
                   (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='N') and (ADN[m,3*(cuentabases-1)+1]='A')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                    ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='M') and (ADN[m,3*(cuentabases-1)+1]='A')
                  and (ADN[m,3*(cuentabases-1)+2]='T') and
                   ((ADN[m,3*(cuentabases-1)+3]='G') or
                   (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='I') and (ADN[m,3*(cuentabases-1)+1]='A')
                  and (ADN[m,3*(cuentabases-1)+2]='T') and
                   ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='H') and (ADN[m,3*(cuentabases-1)+1]='C')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                    ((ADN[m,3*(cuentabases-1)+3]='C') or
                    (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='Q') and (ADN[m,3*(cuentabases-1)+1]='C')
                  and (ADN[m,3*(cuentabases-1)+2]='A') and
                    ((ADN[m,3*(cuentabases-1)+3]='G') or
                    (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='W') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='G') and
                   (ADN[m,3*(cuentabases-1)+3]='G')  then correcto:=true;
                if (proteina[m,n+1]='L') and (ADN[m,3*(cuentabases-1)+1]='C')
                  and (ADN[m,3*(cuentabases-1)+2]='T')  then correcto:=true;
                if (proteina[m,n+1]='S') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='C')  then correcto:=true;
                if (proteina[m,n+1]='R') and (ADN[m,3*(cuentabases-1)+1]='C')
                  and (ADN[m,3*(cuentabases-1)+2]='G')  then correcto:=true;
                if (proteina[m,n+1]='L') and (ADN[m,3*(cuentabases-1)+1]='T')
                  and (ADN[m,3*(cuentabases-1)+2]='T') and
                   ((ADN[m,3*(cuentabases-1)+3]='G') or
                   (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='S') and (ADN[m,3*(cuentabases-1)+1]='A')
                   and (ADN[m,3*(cuentabases-1)+2]='G') and
                   ((ADN[m,3*(cuentabases-1)+3]='C') or
                   (ADN[m,3*(cuentabases-1)+3]='T')) then correcto:=true;
                if (proteina[m,n+1]='R') and (ADN[m,3*(cuentabases-1)+1]='A')
                   and (ADN[m,3*(cuentabases-1)+2]='G') and
                   ((ADN[m,3*(cuentabases-1)+3]='G') or
                   (ADN[m,3*(cuentabases-1)+3]='A')) then correcto:=true;
                if (proteina[m,n+1]='I') and (ADN[m,3*(cuentabases-1)+1]='A')
                  and (ADN[m,3*(cuentabases-1)+2]='T') and
                   (ADN[m,3*(cuentabases-1)+3]='A') then correcto:=true;
         end;
         if correcto=false then
         begin
             fallo := fallo + 1;
             writeln;
             write('  ERROR.');
             writeln(' La traducion de proteinas a acidos nucleicos no es   ');
             writeln('  correcta.                                                   ');
             writeln('   el fallo se encuentra en la: ');
             writeln('   secuencia n ',m);
             writeln('   Posicion del aminoacido=',n+1,'     pos. de codon=',cuentabases);
             write('   aminoacido=',proteina[m,n+1],'  ');
             if proteina[m,n+1]<>'-' then
             begin
               write('                  codon=',adn[m,3*(cuentabases-1)+1]);
               writeln(adn[m,3*(cuentabases-1)+2],adn[m,3*(cuentabases-1)+3]);
             end
             else
                writeln('                  codon=---');
             write('Quieres continuar?(S/N)   ');
             readln(cosa);
             if cosa='N' then
             begin
                   writeln('Revisa tus datos');
                   exit;
             end;
         end;
     end;
     end;
     if fallo>0 then
     begin
          writeln;
          writeln('    ERROR.Las secuencias peptidicas no corresponden con las');
          writeln('    secuencias nucleotidas. Solucionalo y prueba otra vez el');
          writeln('    el programa.');
          writeln('    El programa se ha roto por introducin incorrecta de datos.');
          exit;
     end;
end;




procedure EscribeAntiguo;  (* Escribe un fichero en formato moderno *)
var
   k,n,m,j,z : integer;
begin
     writeln(Serie,'   ',NumEspecies,'  ',TamSecuencia*3);
     for n:= 1 to NumEspecies do
     begin
         k := 0;
         writeln(Serie,Especies1[n]);
         for j:=1 to TamSecuencia do  begin
               if proteina[n,j] = '-' then  begin
                  for m:= 1 to 3 do begin
                   write(Serie,'-');
                     if ((3*(j-1)+m) mod 60 = 0) then  writeln(Serie);
                  end;
               end
               else begin
                  for m:= 1 to 3 do begin
                     write(Serie,ADN[n,3*k+m]);
                     if ((3*(j-1)+m) mod 60 = 0) then writeln(Serie);
                  end;
                  k := k+1 ;
               end;
         end;
         writeln(Serie);
     end;
end;      (* Fin del procedure ESCRIBEANTIGUO *)






BEGIN                     (* del programa  *)
     InicioDelPrograma;
     repeat
           writeln;
           writeln('   Pon un numero para elegir la opcin deseada:');
           writeln;
           writeln('   1    Informacin');
           writeln('   2    Ejecucin del programa');
           writeln('   3    Salir');
           writeln;
           repeat
                 cosa:=readkey;
           until cosa in ['1'..'3'];
           if cosa='1' then Mensaje;
           if cosa='2' then
           begin
                Pregunta;
                LeeFicherosDeEntrada;
                assign(Serie,ficheroResultado);
                rewrite(Serie);
                Comprobacion;
(*                Carga;           *)
                EscribeAntiguo;
                close(Serie);
           end;
     until cosa='3';
     writeln;
     writeln('  FIN DE PROGRAMA PANA ');
     writeln;
end.

